      PROGRAM XREGA
C
C ͻ
C  Program nelinearni regrese. 
C ͼ
C
C Verze 2.3 ANGLICKA: MINIMA+MAXIMA   14:58:19  3/20/1992
C
      INTEGER *2     I04,I05,I07,I15,I16,I23,I31,I47,I64,I80,I81,
     /               I112,I113,I121,I240
      COMMON /SCOLR$/I04,I05,I07,I15,I16,I23,I31,I47,I64,I80,I81,
     /               I112,I113,I121,I240
      CHARACTER *16 HELPFILE,DIRHELP,MATLST(7),LABX,LABY,
     / KALK*80,MTEXT*4(20000),
     / TSED*240,FILE*12
      COMMON M(20000) /SCOM/IS(50) /SDIR$/DIRHELP,HELPFILE /SED$/TSED
     /                /BSPAC$/LINE(20)
      COMMON /GRAF$/IGR(30)
      DIMENSION KAT(9,100),IXG(10),RM(20000)
      DOUBLE PRECISION FKCE,DRES,TFUDP
      LOGICAL IBLOOK,IXLOOK,MTR,GRAFS
      EXTERNAL FKCE,TFUDP,RHELP
      PARAMETER (KESC=27,KF1=59)
      EQUIVALENCE  (KAT(1,1),M(1),MTEXT),
     /(IER,IS(1)), (S,IS(2)), (IS(3),ICT), (IS(4),EPS), (IS(11),ITR),
     /(IEND,IS(13)),(MTR,IS(23)), (LER,IS(26)), (MAS,IS(33)),
     /(MODEL,IS(41)),(ITER,IS(42)), (IRND,IS(43)), (LASRPN,IS(44)),
     /(CORR,IS(45)),(IBLOOK,IS(48)),(IXLOOK,IS(49)),(IX,IS(50)),
     /(IAXIS,IGR(1)),(LABX,IGR(21)),(LABY,IGR(25)),
     /(IPRIM,IGR(8)),(ISECN,IGR(9)),(NLINS,IGR(10)),
     /(ICOLMR,IGR(6)),(ICOLIN,IGR(29)),(ICOLBG,IGR(30)),
     /(M,RM)
      DATA INAME,IATTR,ITEXT,IB,IXR,ICON,IRPN,IXS/2,7,4,5,3,8,9,10/
      DATA LASTM /15/ FILE/'PRN         '/ GRAFS/.FALSE./
      DATA KALK /'                                        Syntax error
     /on the cursor position    '/
      DATAMATLST/'Directory       ',
     /           'Identificators  ',
     /           'Attributes      ',
     /           'Models          ',
     /           'B Bmin Bmax B+- ',
     /           'X-observ. points',
     /           'Structural mat. '/
C
      CALL SCOMIN(-1)
      TSED=
     /'Formats:  I@18I5           E@21I5.@22I5        A@19I5       Compu
     /tations: Eps@4E10.2     Trace@11I5   Random@35I12      Background:
     /   @36I5  Color of line@37I5  Mark_type@39I5     Matrices in COMMO
     /N DIR(9,@34I5)...@24I5,... free up to @25I5'
C
C Prirazeni hodnot pomocnym promennym:
C IX-index matice bodu pozorovani
C
      IX=6
      IENV =I04+2
      DO I=1,30
      IGR(I)=0
      END DO
      LABX='X [-]'
      LABY='Y [-]'
      ICOLIN=7
      ICOLMR=27
      ICOLBG=0
      NLINS=1
      IPRIM=1
      ISECN=1
      IAXIS=3
      CALL SCLEAR
      GOTO 10
C
C Bod uplne regenerace
C
111   IBLOOK=.TRUE.
      IXLOOK=.TRUE.
      HELPFILE='MEDREGA.HLP'
C
C DISPLAY aktivni regresni funkce, pocet parametru, bodu pozorovani, etc.
C
11    CALL SCPAGE(0,12288,2000)
      CALL SCPAGS(3)
      CALL SCWAIT
      CALL SFRAME(0,0,4,79,I16,-I23,0,I,I)
      CALL MPANEL(1,3, I23,I07,
     /'No. of iterations: @-42I6 random trials: @-43I6   extrapolations:
     / @-3I5 '//
     /'Correl.index: @-45F11.7     Standard deviation of data: @-2E15.7
     /       '//
     /'No.of regression parameters M=@41I5        linear parameters MLIN
     /=@38i5 ',3,18,18,M)
      DO I=5,7
      CALL SCWRIT(I,0,80,7,LINE)
      END DO
      LLT=KAT(1,ITEXT)
      NDT=KAT(8,ITEXT)
      MTX=KAT(5,ITEXT)
      NTX=KAT(6,ITEXT)
      CALL SCWRIT(6,0,NTX*4,I23,M(LLT+NDT*MODEL))
      CALL SFRAME(8,0,24,35,I16,-I23,0,I,I)
      LLB=KAT(1,IB)
      NBM=KAT(5,IB)
      CALL MPANEL(10,2,I23,I07,
     /' Model parameters:  '//
     /'                    '//
     /' B1  @1E15.5        '//
     /' B2  @2E15.5        '//
     /' B3  @3E15.5        '//
     /' B4  @4E15.5        '//
     /' B5  @5E15.5        '//
     /' B6  @6E15.5        '//
     /' B7  @7E15.5        '//
     /' B8  @8E15.5        '//
     /' B9  @9E15.5        '//
     /' B10 @10E15.5       '//
     /' B11 @11E15.5       '//
     /' B12 @12E15.5       ',
     / MIN0(14,NBM+2),5,5,M(LLB))
      IF(NBM.LE.9)THEN
         CALL SCWRIT(21,3,19,I23,'XREG Version 2.3/99')
         CALL SCWRIT(22,3,19,I23,'@Zitny  CVUT Prague')
      ENDIF
      CALL SCPAGS(0)
C
C Zakladni menu
C
1     CALL SWAP(I07,I23)
      CALL MENU(0,'Main menu:',10,8,36,
     /'Read    data from file        XREGA.MAT '//
     /'Write   data into file        XREGA.MAT '//
     /'Edit    matrix                      >   '//
     /'Print   matrix                      >   '//
     /'TOOLs (Load/Save/Colors [F10])          '//
     /'Calculator                              '//
     /'Select       regression function        '//
     /'User defined regression function        '//
     /'Method of solution                      '//
     /'Number of iteration, accuracy,....      '//
     /'Initial estimate of parameters          '//
     /'Analysis (Regression + prediction)      '//
     /'Graph parameters (axis, fuctions)       '//
     /'View graph                              '//
     /'Quit                                    ',LASTM
     /,10,10,1,IA)
      CALL SWAP(I07,I23)
      GOTO(10,20,30,40,50,60,70,80,90,100,110,110,130,140,150),IA
      GOTO 1
C
C Cteni vsech matrixovych poli
C
10    CALL MTOBIR('XREGA.MAT',IEND)
      IA=7
      GOTO 111
C
C Zapis vsech matrixovych poli
C
20    CALL MTOBIW('XREGA.MAT')
      GOTO 1
C
C Editace
C
30    CALL MENU(-IENV,'Edit matrix',11,14,15,MATLST,7,4,4,1,MAT)
      IF(MAT.EQ.6) MAT=IX
      IF(MAT.EQ.7) MAT=10
      IF(MAT.EQ.3) MAT=IATTR
      IF(MAT.GT.0) THEN
          CALL SCLEAR
          CALL MEDS(MAT,rhelp)
      ENDIF
      GOTO 11
C
C Vystup jednoho pole
C
40    CALL MENU(-IENV,'Print matrix',12,14,15,MATLST,7,4,4,1,MAT)
      IF(MAT.LE.0) GOTO11
      MATS=MAT
      IF(MAT.EQ.6)MAT=IX
      IF(MAT.EQ.7)MAT=10
      IF(MAT.EQ.3)MAT=IATTR
      CALL MENU(0,'Format',6,14,35,'Plain form      Row numbering   Attr
     /ibutes      ',3,4,4,1,ICT1)
      ICTF=0
      IF(ICT1.EQ.2)ICTF=200
      IF(ICT1.EQ.3)ICTF=10200
      CALL MINPT(-IENV,'File:',5,23,15,FILE,12)
      IF(IEND.EQ.KESC)GOTO11
      OPEN(10,FILE=FILE,ERR=50)
      IF(MAT.EQ.5)THEN
        MTR=.FALSE.
        CALL MLOC(4,MODEL+1,1,LOC1,ITYP)
        WRITE(10,42)(M(L),L=LOC1,LOC1+9)
42      FORMAT(/5X,10A4)
      ENDIF
      WRITE(10,41)MATLST(MATS)
41    FORMAT(/5X,A)
      CALL MWRITE(MAT,ICTF,10)
      CLOSE (10)
      IF(FILE(1:3).EQ.'CON') CALL SKBDR(KBD)
      GOTO 11
C
C MTOOLS-prohlizeni matic, cteni/zapis do zvolenych souboru.
C
50    CALL MTOOLS(0,RHELP)
      CALL SCLEAR
      GOTO 11
C
C Kalkulacka (pouzitelne promenne jsou deklarovany v datech, viz pole IDENTIF)
C
60    IFP=4
      CALL SCDARK(I04)
      CALL VARLIST
      CALL TPUTCR(1,' ',40,KALK)
62    JCRS=1
      MROW=1
63    CALL MENE(1,'Expression or assignment',24,21,0,KALK,
     /MROW,10,1,1,1,JCRS)
      IF(IEND.EQ.KESC) GOTO 11
      CALL TUPC(26,KALK,KALK)
      CALL MPARA(ICON,I,I,I,I,LOCON,LECON)
      CALL MPARA(IRPN,I,I,I,I,LORPN,LERPN)
      CALL TRANSE(KALK,26,0,M(KAT(1,INAME)),M(KAT(1,IATTR)),
     / KAT(6,IATTR),KAT(2,INAME),LOCON,LOCON+LECON-1,LERPN,LASCON,
     / LASRPN,M,M(LORPN))
      IF(IER.EQ.0) GOTO 65
      IF(IER.GT.0) GOTO 11
      JCRS=-IER/10000
      MROW=2
      GOTO 63
65    CALL TINEDP(M(KAT(1,IRPN)),LASRPN,M,TFUDP,DRES)
      IF(IER.NE.0)GOTO11
      RES=DRES
      CALL TPUTRE(29,RES,11,3,KALK)
      GOTO 62
C
C  vyber regresni funkce (modelu)
C
70    MODL=MODEL+1
      CALL MENU(IENV,'Model:',6,22-MTX,0,M(LLT),MTX,NTX,NDT,5,MODL)
      IF(MODL.GT.0)MODEL=MODL-1
      MODL=MODEL+1
      IF(MODEL.EQ.0)THEN
           KAT(2,IB)=MIN0(KAT(2,IB),KAT(5,IB))
      ELSEIF(MODEL.EQ.1.OR.MODEL.EQ.2.OR.MODEL.EQ.6)THEN
           KAT(2,IB)=KAT(5,IB)
      ELSEIF(MODEL.EQ.3.OR.MODEL.EQ.5)THEN
           KAT(5,IB)=3
           KAT(2,IB)=2
      ELSEIF(MODEL.EQ.4)THEN
           KAT(5,IB)=5
           KAT(2,IB)=3
      ENDIF
      IA=10
      IF(IEND.NE.KESC) IBLOOK=.TRUE.
      GOTO111
C
C Editace regresni funkce c.1
C
80    CALL SCDARK(I04)
      CALL VARLIST
      CALL MENU(0,'Edit:',5,21,0,M(LLT),1,NTX,NDT,8,IDUMMY)
      IF(IEND.NE.KESC)IBLOOK=.TRUE.
      IA=12
      GOTO11
C
C Volba metody a ICT (ridici parametr algoritmu)
C
90    CALL MENU(-IENV,'Solution by:',12,19,15,
     /         'Marquardt-KvetonMarquardt-Zitny ',2,4,4,5,METD)
      IF(METD.EQ.1) ICT=0
      IF(METD.EQ.2)THEN
         CALL MINPI(-IENV,
     /' No.of iterations for extrapolation: ',37,23,2,ICT)
         IF(ICT.LT.0.OR.ICT.GT.20)ICT=0
      ENDIF
      IA=10
      GOTO 11
C
C Parametry metody (Pocet iteraci/Nahodnych pokusu/Presnost/Vyukovy rezim/
C                   index aktivni matice bodu pozorovani)
C
100   CALL MINPVX(IENV,'[Enter] [F9] ',13,20,0,
     /'Max. number of iterat.@42I5 , no. of random trials@43I5 '//
     /'Relative accuracy  |delta B|   @4E9.1                   '//
     /'Trace level @11I5 (0-5), matrix of data points no.@50I5 ',
     /3,14,IS)
      KAT(4,IXS)=IX
      IA=12
      GOTO 1
C
C Preklad modelu a vyhodnoceni
C IA=11  - manualni nastaveni parametru Bi
C    12  - regrese MREMAR
C    14  - graf
C
110   CONTINUE
      IF(IXLOOK)           CALL MEDS(IX,RHELP)
      IF(IBLOOK)THEN
          DO119I=1,6000
              CALL SCWRIT(23,3,21,MOD(I,128),'> Parameters estimate')
              CALL SKBDS(KBD)
              IF(KBD.NE.0) GOTO 118
119       CONTINUE
118       IF(KBD.EQ.KESC) GOTO 1
          CALL MEDS(5,RHELP)
      ENDIF
140   IF(MODEL)1,1100,2000
1100  CALL MPARA(ICON,I,I,I,I,LOCON,LECON)
      CALL MPARA(IRPN,I,I,I,I,LORPN,LERPN)
      CALL MLOC (ITEXT,1,1,LOTEXT,ITYP)
      LER4=LER*4
      CALL TUPC (LER4,MTEXT(LOTEXT),MTEXT(LOTEXT))
      CALL TRANSE(MTEXT(LOTEXT),LER4,0,M(KAT(1,INAME)),M(KAT(1,IATTR)),
     / KAT(6,IATTR),KAT(2,INAME),LOCON,LOCON+LECON-1,LERPN,LASCON,
     / LASRPN,M,M(LORPN))
      IF(IER.LT.0)THEN
           CALL SMALLC(MTEXT(LOTEXT),LER4,-IER)
           IF(IEND.EQ.KESC)GOTO 11
           GOTO 80
      ENDIF
2000  MAS=0
C Adjust Weights (max <1)
      CALL MPARA(IX,KOD,MAP,MROWS,NCOLS,LOC,LENGTH)
      CALL DEKOD(KOD,NXG,IXG,IYG,IWG,IPG)
      IF(IWG.GT.0.AND.IWG.LE.NCOLS)THEN
         WMAX=1E-10
         DO IROW=1,MROWS
            CALL MLOC(IX,IROW,IWG,LS,IT)
            WMAX=AMAX1(WMAX,RM(LS))
         ENDDO
         DO IROW=1,MROWS
            CALL MLOC(IX,IROW,IWG,LS,IT)
            RM(LS)=RM(LS)/WMAX
         ENDDO
      ENDIF
      IF(IA.EQ.11)THEN
C MANUAL estimate
         CALL MPARD(IB,KODI,I,MB,I,LOCB,MBD)
         CALL ESTIMC(IX,M(LOCB),MB,MBD,KODI)
      ELSEIF(IA.EQ.14)THEN
C GRAF
         IF(.NOT.GRAFS) GOTO 130
         CALL GRAF(.TRUE.,0.,1.,.06,1.,0)
      ELSE
C REGRESE
         CALL MREMAR(IX,IB,ITER,IRND,FKCE,M(KAT(1,IXR)))
         CALL REWRIT
      ENDIF
      CALL CORREL
      GOTO 11
C
C axis definition
C
130   KOD=KAT(2,IX)
      CALL DEKOD(KOD,NXG,IXG,IYG,IWG,IPG)
      IGR(2)=IXG(1)
      IGR(3)=IXG(1)
      IGR(4)=IYG
C      IGR(5)=IPG
      IF(NXG.EQ.1)THEN
         NLINES=12
      ELSEIF(NXG.EQ.2)THEN
         NLINES=14
      ELSEIF(NXG.GT.2)THEN
         NLINES=12+NXG
      ENDIF
      CALL MINPVX(IENV,'[Enter] [F9] ',13,23-NLINES,0,
     /'Axis @1i4  [ 0-log/log 1-log/a 2-a/log 3-a/a ]          '//
     /'           [ 4         5       6       7     ] ticks    '//
     /'Background color @30i6                                  '//
     /'Horizontal axis label:  @21a16                          '//
     /'Vertical   axis label:  @25a16                          '//
     /'Points           Column X      Column Y       Mark      '//
     /'                 C@2i6         C@4i6          C@6i6     '//
     /'                 C@3i6         C@5i6          C@7i6     '//
     /'                     Negative value of mark      '//
     /'                     is interpreted as column index.    '//
     /'Model:                                                  '//
     /'Primary   variable X(@8i4) line color @29i5             '//
     /'Secondary variable X(@9i4) no. of discrete values @10i5 '//
     /'values: @11e11.3    @12e11.3    @13e11.3    @14e11.3    '//
     /'Fixed     variable X(@15i5)=@18e12.3                    '//
     /'Fixed     variable X(@16i5)=@19e12.3                    '//
     /'Fixed     variable X(@17i5)=@20e12.3                    ',
     /NLINES,14,IGR)
      GRAFS=.TRUE.
      IF(IEND.EQ.KESC)THEN
          GRAFS=.FALSE.
          GOTO 1
      ENDIF
      IA=14
      GOTO 140
C
C Konec ulohy
C
150   CALL SCLEAR
      END

      SUBROUTINE ESTIMC(IX,B,MPAR,MBD,MLIN)
C
C Nonlinear parameters estimate - contours drawing
C
      PARAMETER (IB=5,IXR=3,NC=10)
      INTEGER *2     I04,I05,I07,I15,I16,I23,I31,I47,I64,I80,I81,
     /               I112,I113,I121,I240
      COMMON /SCOLR$/I04,I05,I07,I15,I16,I23,I31,I47,I64,I80,I81,
     /               I112,I113,I121,I240
      DOUBLE PRECISION FKCE
      LOGICAL GRAF4
      EXTERNAL FKCE
      DIMENSION B(MBD,*),IEST(14),REST(14),RA(20000),KAT(9,100),
     / VC(NC),IVC(NC),WX1(6),WX2(6),WY1(6),WY2(6)
      COMMON /SCOM/IS(50) //MA(20000)
      CHARACTER *2 LAB1,LAB2,LAB3,LAB*10,LABQ*4,LABPT*59
      EQUIVALENCE (NB1,IEST(6)),(NB2,IEST(7)),(NB3,IEST(8)),
     /            (B1MI,IEST(9)) ,(B1MA,IEST(12)),
     /            (B2MI,IEST(10)),(B2MA,IEST(13)),
     /            (B3MI,IEST(11)),(B3MA,IEST(14)),
     /            (IMI,IS(24)),(IMA,IS(25)),(IEST,REST),
     /            (S,IS(2)),(MA,RA,KAT)
      DATA IVC/5,6,7,8,9,10,11,12,13,14/
      DATA WX1/0.,.3333,.6667,0.,.3333,.6667/
      DATA WX2/.3333,.6667,1.,.3333,.6667,1./
      DATA WY1/0.,0.,0.,.5,.5,.5/
      DATA WY2/.5,.5,.5,1.,1.,1./
      DATA LABPT/'Locate parameters B                                '/
C
      IMIS=IMI
      MNELI=MIN0(3,MPAR-MLIN)
      MLIN1=MLIN+1
      MLIN2=MLIN+2
      MLIN3=MLIN+3
      IF(MNELI.LE.0)GOTO9999
      DOK=1,MNELI
         IEST(K+2)=K+MLIN
         REST(K+8)=B(K+MLIN,1)-B(K+MLIN,4)
         REST(K+11)=B(K+MLIN,1)+B(K+MLIN,4)
      ENDDO
      NB2=1
      NB3=1
      IF(MNELI.EQ.1)THEN
         NB1=50
      ELSEIF(MNELI.EQ.2)THEN
         NB1=15
         NB2=15
      ELSE
         NB1=8
         NB2=8
         NB3=6
      ENDIF
      CALL MINPVX(I04+2,'Set range of nonlinear parameters: ',35,
     /21-MNELI,0,
     /'        min        max       no.of points   '//
     /' B#3i4 @9e10.2    @12e10.2       @6i5       '//
     /' B#4i4 @10e10.2   @13e10.2       @7i5       '//
     /' B#5i4 @11e10.2   @14e10.2       @8i5       ',
     /MNELI+1,11,IEST)
      IF(NB1.LE.0.OR.NB2.LE.0.OR.NB3.LE.0) GOTO 9999
      LB=IMI+1
      LS=LB+MBD
      N123=NB1*NB2*NB3
      IMI=LS+N123
      NTIC=N123/40+1
      LTIC=N123/NTIC
      WRITE(LAB1,10)MLIN1
      WRITE(LAB2,10)MLIN2
      WRITE(LAB3,10)MLIN3
10    FORMAT('B',I1)
C regrese s ukladanim S
      ITER=-1
      DOI=1,MPAR
      RA(LB+I-1)=B(I,1)
      ENDDO
C pocatecni hodnota souctu ctvercu
      CALL MREMAR(IX,IB,0,0,FKCE,MA(KAT(1,IXR)))
      S0=S
      B1OPT=B(MLIN1,1)
      B2OPT=B(MLIN2,1)
      B3OPT=B(MLIN3,1)
      IF(MLIN.LE.0) ITER=0
      QUOC=1.1
20    SMIN=1E10
      SMAX=0.
      DB1=0.
      DB2=0.
      DB3=0.
      IF(NB1.GT.1) DB1=(B1MA-B1MI)/(NB1-1)
      IF(NB2.GT.1) DB2=(B2MA-B2MI)/(NB2-1)
      IF(NB3.GT.1) DB3=(B3MA-B3MI)/(NB3-1)
      B3=B3MI
      LOC=LS
      ITIC=38
      CALL SCWRIT(23,LTIC+ITIC,1,I07,'')
      DOK=1,NB3
         IF(MLIN3.LE.MPAR) B(MLIN3,1)=B3
         B2=B2MI
         DOJ=1,NB2
           IF(MLIN2.LE.MPAR) B(MLIN2,1)=B2
           B1=B1MI
           DOI=1,NB1
             IF(MLIN1.LE.MPAR) B(MLIN1,1)=B1
             CALL MREMAR(IX,IB,ITER,0,FKCE,MA(KAT(1,IXR)))
             IF(MOD(LOC,NTIC).EQ.0)THEN
                ITIC=ITIC+1
                CALL SCWRIT(23,ITIC,1,I07,'')
             ENDIF
             CALL SKBDS(KBD)
             IF(KBD.NE.0) GOTO 9999
             RA(LOC)=S
             LOC=LOC+1
             IF(S.LT.S0)THEN
                DOL=1,MPAR
                RA(LB+L-1)=B(L,1)
                ENDDO
                S0=S
                B1OPT=B1
                B2OPT=B2
                B3OPT=B3
             ENDIF
             SMIN=AMIN1(S,SMIN)
             SMAX=AMAX1(S,SMAX)
             B1=B1+DB1
           ENDDO
           B2=B2+DB2
         ENDDO
         B3=B3+DB3
      ENDDO
C
C ulozeni nejlepsiho vysledku
C
      DOL=1,MPAR
      B(L,1)=RA(LB+L-1)
      ENDDO
      S=S0
C
C zobrazeni vysledku
C
      CALL GMFIN
      WX=1.
      GRAF4=.FALSE.
50    IMARK=11
53    CALL GMFSYL(LAB1,2,LAB2,2)
      DS=(SMAX-SMIN)*(1-QUOC)/(1-QUOC**NC)
      SS=SMIN
      DOK=1,NC
        VC(K)=SS
        SS=SS+DS
        DS=DS*QUOC
      ENDDO
      IF(MNELI.EQ.1)THEN
         CALL GMFST(1,0.,WX,.1,1.,B1MI,B1MA,SMIN,SMAX)
         CALL GMFSYL(LAB1,2,'s  ',3)
         CALL GMFAXL(1,87,11)
         CALL GMFPLD(B1MI,DB1,NB1,RA(LS),1)
52       CALL SCWRIT(24,0,31,I16,
     /'[F1]-Zoom  [F4]-graph [F9]-quit')
         IF(IMARK.GT.11) CALL GMFMRK(B1OPT,S,IMARK-1)
         IF(GRAF4)THEN
             IEND=62
         ELSE
             CALL SKBDR(IEND)
         ENDIF
51       IF(IEND.EQ.59)THEN
         CALL GMFLCW(B1MI,B1MA,SMIN,SMAX,B1MI,B1MA,SMIN,SMAX,IEND)
             IF(IEND.EQ.13.AND.B1MI.LT.B1MA) GOTO20
             GOTO 51
         ELSEIF(IEND.EQ.62)THEN
             CALL SCWRIT(24,0,31,I16,LABPT)
             CALL GMFLCQ(1,B1OPT,SMIN,B1OPT,SMIN,KBD)
             GRAF4=KBD.EQ.13
             B(MLIN1,1)=B1OPT
             CALL MREMAR(IX,IB,ITER,0,FKCE,MA(KAT(1,IXR)))
             CALL GRAF(.FALSE.,.5,1.,0.1,1.,IMARK)
             IMARK=IMARK+1
             IF(WX.EQ..5)THEN
                CALL GMFSW(1)
                GOTO 52
             ENDIF
             WX=.5
             GOTO 53
         ENDIF
      ELSEIF(MNELI.EQ.2)THEN
         CALL GMFST(11,0.,WX,.1,1.,B1MI,B1MA,B2MI,B2MA)
         CALL GMFCRN(1,' ',0,RA(LS),NB1,NB2,B1MI,B1MA,B2MI,B2MA,
     /               VC,IVC,NC,1)
         CALL GMFMRK(B1OPT,B2OPT,10)
         WRITE(LABQ,60)QUOC
60       FORMAT(F4.2)
62       CALL SCWRIT(24,0,59,I16,
     /'[F1]-Zoom [F2]-scale:'//LABQ//
     /' [F3]-rescale [F4]-graph [F9]-quit')
         IF(IMARK.GT.11) CALL GMFMRK(B1,B2,IMARK-1)
         IF(GRAF4)THEN
             IEND=62
         ELSE
             CALL SKBDR(IEND)
         ENDIF
61       IF(IEND.EQ.59)THEN
         CALL GMFLCW(B1MI,B1MA,B2MI,B2MA,B1MI,B1MA,B2MI,B2MA,IEND)
             IF(IEND.EQ.13) GOTO20
             GOTO 61
         ELSEIF(IEND.EQ.60)THEN
             QUOC=QUOC*1.25
         ELSEIF(IEND.EQ.61)THEN
             QUOC=1.05
         ELSEIF(IEND.EQ.62)THEN
             CALL SCWRIT(24,0,59,I16,LABPT)
             IF(WX.EQ.1.)THEN
                B1=(B1MA+B1MI)*.5
                B2=(B2MA+B2MI)*.5
             ENDIF
             CALL GMFLCP(B1,B2,B1,B2,IEND)
             GRAF4=IEND.EQ.13
             B(MLIN1,1)=B1
             B(MLIN2,1)=B2
             CALL MREMAR(IX,IB,ITER,0,FKCE,MA(KAT(1,IXR)))
             CALL GRAF(.FALSE.,.5,1.,0.1,1.,IMARK)
             IMARK=IMARK+1
             CALL GMFSYL(LAB1,2,LAB2,2)
             IF(WX.EQ..5)THEN
                CALL GMFSW(1)
                GOTO 62
             ENDIF
             WX=.5
             GOTO53
         ENDIF
      ELSEIF(MNELI.EQ.3)THEN
         LOC=LS
         B3=B3MI
         DOK=1,NB3
         WRITE(LAB,70)B3
70       FORMAT('=',E9.2)
         CALL GMFST(K+10,WX1(K),WX2(K),WY1(K),WY2(K),
     /               B1MI,B1MA,B2MI,B2MA)
         CALL GMFCRN(K,' '//LAB3//LAB,13,RA(LOC),NB1,NB2,
     /               B1MI,B1MA,B2MI,B2MA,VC,IVC,NC,1)
         LOC=LOC+NB1*NB2
         B3=B3+DB3
         ENDDO
         CALL SKBDR(IEND)
         IF(IEND.EQ.60)THEN
             QUOC=QUOC*1.25
         ELSEIF(IEND.EQ.61)THEN
             QUOC=1.05
         ENDIF
      ENDIF
      B(MLIN1,4)=(B1MA-B1MI)*.5
      IF(MNELI.GE.2)B(MLIN2,4)=(B2MA-B2MI)*.5
      IF(MNELI.EQ.3)B(MLIN3,4)=(B3MA-B3MI)*.5
      IF(IEND.NE.27.AND.IEND.NE.67) GOTO50
9999  CALL GMFMON
      IMI=IMIS
      END

      SUBROUTINE MINPVX(IENV,LAB,NL,IR,IC,ITEXT,M,N,IV)
      DIMENSION LAB(*),ITEXT(*),IV(*)
      INTEGER *2     I04,I05,I07,I15,I16,I23,I31,I47,I64,I80,I81,
     /               I112,I113,I121,I240
      COMMON /SCOLR$/I04,I05,I07,I15,I16,I23,I31,I47,I64,I80,I81,
     /               I112,I113,I121,I240
      CALL SWAP(I07,I23)
      CALL MINPV(IENV,LAB,NL,IR,IC,ITEXT,M,N,IV)
      CALL SWAP(I07,I23)
      END

      SUBROUTINE SMALLC(IT,LT,JOUT)
      INTEGER *1 IT(*)
      DO20I=JOUT/10000,LT
      IF(IT(I).GE.65.AND.IT(I).LE.90) IT(I)=IT(I)+32
20    CONTINUE
      END

      SUBROUTINE SWAP(I1,I2)
      INTEGER *2 I1,I2,IP
      IP=I1
      I1=I2
      I2=IP
      END

      SUBROUTINE VARLIST
      INTEGER *2     I04,I05,I07,I15,I16,I23,I31,I47,I64,I80,I81,
     /               I112,I113,I121,I240
      COMMON /SCOLR$/I04,I05,I07,I15,I16,I23,I31,I47,I64,I80,I81,
     /               I112,I113,I121,I240
      COMMON IM(20000)
      DIMENSION KAT(9,100)
      EQUIVALENCE (KAT,IM)
      CALL SFRAME(0,56,20,79,I16,-I23,0,I,I)
      CALL MPANEL(1,58, I23,I07,
     /'Standard functions: '//
     /'$6 sin() cos()      '//
     /'   log() lgt() exp()'//
     /'   abs() sqr() $    '//
     /'Standard operators: '//
     /'$6 + - * / ** ( )   '//
     /'   < > = <= >= & | $'//
     /'User defined identif'//
     /'     default meaning'//
     /'@1a4 simple var. X  '//
     /'@2a4() vector of X  '//
     /'@3a4 1.parameter B1 '//
     /'@4a4 2.parameter B2 '//
     /'@5a4 3.parameter B3 '//
     /'@6a4 4.parameter B4 '//
     /'@7a4 5.parameter B5 '//
     /'@8a4 6.parameter B6 '//
     /'@9a4() vector of B  '//
     /'@11a12      no.pars.',19,5,5,IM(KAT(1,2)))
      END

      DOUBLE PRECISION FUNCTION FKCE(X,B,N)
C
C Regresni funkce (index aktivniho modelu MODEL je v zone /SCOM/)
C          X-vektor bodu pozorovani, B-parametry modelu, N-pocet parametru
C MODEL=0 interakcni definice
C      =1 y=b1*x^(n-1)+...+bn
C      =2 y=b1 +b2*x1+...+bn*x(n-1)
C      =3 y=b1*exp(b3*x)+b2
C      =4 y=b1*exp(b4*x)+b2*exp(b5*x)+b3
C      =5 y=(b1+b2*x)/(1+b3*x)
C      =6 y=(b1*T(0,x)+b2*T(1,x)+...+bn*T(n-1,x))
C      =7 y=(b1*L(1,x,a)+b2*L(2,x,a)+....+
C
      COMMON/SCOM/IS(50)//M(10000)
      DIMENSION K(9,100),X(15),B(1)
      DOUBLE PRECISION R,TFUDP,AUX,TCHEB,TCHEB0,TCHEB1,ARG
      EQUIVALENCE(K(1,1),M(1)),(MODEL,IS(41)),(LASRPN,IS(44)),
     /           (IS(1),IER)
      EXTERNAL TFUDP
      IER=0
      ISW=MODEL+1
      GOTO (10,20,30,40,50,60,70,80), ISW
10    CALL TINEDP(M(K(1,9)),LASRPN,M,TFUDP,R)
      GOTO 100
20    R=B(N)
      N1=N-1
      DO21I=1,N1
21    R=R*X(1)+B(N-I)
      GOTO100
30    N1=N-1
      R=B(1)
      DO31I=1,N1
31    R=R+B(I+1)*X(I)
      GOTO100
40    ARG=B(3)*X(1)
      IF(ARG.GT.30.)THEN
      IER=1
      ARG=30.
      ENDIF
      R=B(1)*EXP(ARG)+B(2)
      GOTO 100
50    ARG1=B(4)*X(1)
      IF(ARG1.GT.30.)THEN
      IER=1
      ARG1=30.
      ENDIF
      ARG2=B(5)*X(1)
      IF(ARG2.GT.30.)THEN
      IER=1
      ARG2=30.
      ENDIF
      R=B(1)*EXP(ARG1)+B(2)*EXP(ARG2)+B(3)
      GOTO 100
60    R=(B(1)+B(2)*X(1))/(1+B(3)*X(1))
      GOTO 100
C CHEBYSHEW first kind
70    R=0.
      ARG=X(1)
      TCHEB0=1.
      TCHEB1=ARG
      R=TCHEB0*B(1)
      IF(N.GT.1)R=R+TCHEB1*B(2)
      DO71I=3,N
         TCHEB=2*ARG*TCHEB1-TCHEB0
         TCHEB0=TCHEB1
         TCHEB1=TCHEB
71    R=R+B(I)*TCHEB
      GOTO 100
C lAGUERROVY FUNKCE
80    AT=B(N)*X(1)
      IF(ABS(AT).GT.30.)THEN
         R=0.
      ELSE
      SQE=SQRT(ABS(B(N)))*EXP(-AT*.5)
C Laguerrovy funkce L(a,t); zadava se AT=a.t
C SQE=sqrt(a).exp(-at/2)
C pouziva se rekurence WHITE a ANDERSEN
      R1=SQE
      R2=SQE*(1.-AT)
      R=B(1)*R1+B(2)*R2
      DO KK=1,N-3
      R3=((2*KK+1-AT)*R2-KK*R1)/(KK+1)
      R1=R2
      R2=R3
      R=R+B(KK+2)*R3
      ENDDO
      ENDIF
100   FKCE=R
      RETURN
      END

      SUBROUTINE RHELP(I,ITX,J1,J2,ICT)
C
C Zobrazovani popisu jednotlivych matic a napovedy (procedurou MHELP).
C Graficke znazorneni dat x,y zvolenych sloupcu matice bodu pozorovani.
C
      EXTERNAL SCOLOS
      LOGICAL IXLOOK,IBLOOK
      DIMENSION KAT(9,100),ITX(*)
      COMMON M(10000) /SCOM/IS(50)
      EQUIVALENCE (MODL,IS(41)),(IBLOOK,IS(48)),(IXLOOK,IS(49)),
     /            (IX,IS(50))  ,(M,KAT),(IOUT,IS(12)),
     /            (LABEL,KAT(1,13)),(NLAB,KAT(8,13)),(MLAB,KAT(5,13))
      IF((ICT.EQ.43.OR.ICT.EQ.54.OR.ICT.EQ.53).AND.I.LE.MLAB)
     /    CALL MPANEL(1,2, 7,7,M(LABEL+(I-1)*NLAB),1,NLAB,NLAB,M)
C F10 External functions
      IF(ICT.EQ.55) THEN
          CALL SCOLOR(5,1,SCOLOS)
          IOUT=3
      ELSEIF(ICT.EQ.45)THEN
          CALL MENU(1,' ',0,12,49,
     /'Set no. of parameters B  23 '//
     /'Set column meaning    X  23 '//
     /'Logarithmic transform.    1 '//
     /'Edit label                1 '//
     /'Read  ASCII matrix        7 '//
     /'Journal (previous res.)   1 ',6,6,7,3,ISEL)
          IF(ISEL.EQ.1)THEN
             CALL MODEL (45,I)
          ELSEIF(ISEL.EQ.2)THEN
             CALL SETKOD(45,I)
          ELSEIF(ISEL.EQ.3)THEN
             CALL TRALOG(IX)
          ELSEIF(ISEL.EQ.4)THEN
             CALL MENU(1,' ',0,0,0,M(LABEL+(I-1)*NLAB),1,NLAB,NLAB,8,L)
          ELSEIF(ISEL.EQ.5)THEN
             CALL MIMP(I,16,40)
          ELSEIF(ISEL.EQ.6)THEN
             CALL REPORT
          ENDIF
          IOUT=3
      ENDIF
C Uvodni zadavaci panely
      IF(I.EQ.5 .AND.ICT.EQ.43) CALL MODEL (ICT,I)
      IF(I.EQ.IX.AND.ICT.EQ.43) CALL SETKOD(ICT,I)
      CALL REXPRC(ITX)
      CALL MEDENT(I,ITX,J1,J2,ICT)
      END

      SUBROUTINE REXPRC(LINE)
C
C analyza LINE (76 znaku) a nahrazeni Cnnn > C(nnn)
C
      CHARACTER *1 LINE(*)
      DO10IEND=1,76
      IF(LINE(IEND).EQ.'\')GOTO11
10    CONTINUE
11    IEND1=IEND-1
      IEND2=IEND-2
      DO1I=1,IEND1
      IF(LINE(I).EQ.'C')THEN
         J=I+1
         IF(LINE(J).GE.'1'.AND.LINE(J).LE.'9')THEN
            DO2K=IEND2,J,-1
 2          LINE(K+1)=LINE(K)
            LINE(J)='('
            DO3K=J+2,IEND2
            IF(LINE(K).LT.'0'.OR.LINE(K).GT.'9')GOTO 4
 3          CONTINUE
 4          DO5J=IEND2,K,-1
 5          LINE(J+1)=LINE(J)
            LINE(K)=')'
         ENDIF
      ENDIF
1     CONTINUE
      END

      SUBROUTINE REPORT
C
C Vyvolani editoru zprav (pole cislo 11)
C
      EXTERNAL SEMPTY
      INTEGER *2 ICOLR
      COMMON IM(20000) /SCOLR$/ICOLR(15)
      DATA IP,JP,MW,NW,ICT /2,0,19,19,9/
      CALL MPARB(11,KOD,MAP,IT,M,N,LOCT,MDIM,LEN)
      KOD1=MAX0(1,KOD-MW+1)
      ICRS=KOD-KOD1+2
      JCRS=0
      CALL MENS(1,ICOLR(3),IM(LOCT),M,MDIM,0,0,24,79,MW,NW,IP,JP,
     /          KOD1,ICT,IA,ICRS,JCRS,SEMPTY)
      END

      SUBROUTINE REWRIT
C
C Zapis JOURNAL do vnitrniho souboru
C
      CHARACTER *4 MAC(20000),LINEW(20),LINE*80
      COMMON RA(20000) /SCOM/ISS(50) /BLINE$/LINE
      DIMENSION KAT(9,100)
      EQUIVALENCE (S,ISS(2)),(KAT,RA,MAC),(MODL,ISS(41)),(LINE,LINEW)
      CALL TPUTCR(1,' ',80,LINEW)
      CALL MPARB(11,KODLIN,MAP,IT,M,N,LOCT,MDIM,LEN)
      IF(KODLIN.LT.M-1)THEN
         LOCT=LOCT+KODLIN*MDIM
         KODLIN=KODLIN+2
      ELSE
         CALL MCOPY$(LOCT+2*MDIM,LOCT,(M-2)*MDIM)
         LOCT=LOCT+(M-2)*MDIM
      ENDIF
      CALL MLOCR(4,MODL+1,1,LOC,IT,LEN,IDR)
      LENMXX=MIN0(19,LEN-1)
      WRITE(LINE,1)(MAC(I),I=LOC,LOC+LENMXX)
1     FORMAT(20A4)
      DO10I=1,MDIM
      MAC(LOCT)=LINEW(I)
10    LOCT=LOCT+1
      CALL MPARA(5,KOD,MAP,M,N,LOC,LEN)
      M=MIN(5,M)
      CALL TPUTCR(1,' ',80,LINEW)
      WRITE(LINE,2)S,(RA(I),I=LOC,LOC+M-1)
2     FORMAT('Std:',E12.5,' B:',5E10.3)
      DO20I=1,MDIM
      MAC(LOCT)=LINEW(I)
20    LOCT=LOCT+1
      KAT(2,11)=KODLIN
      END

      SUBROUTINE MEDHED(N,LEN,LIST,LTEXT)
C
C Doplneni popisu sloupcu
C
      INTEGER *2 ICOLR,IC
      CHARACTER LIST(N)*2, LTEXT(N)*4, LINE*80, L2*2
      COMMON /BLINE$/LINE /SCOLR$/ICOLR(15)
      EQUIVALENCE (ICOLR(6),IC)
      PARAMETER (LAST=71,LBUF=72)
      CALL SCWRIT(24,68,10,IC,' MENU-F10 ')
      CALL SCREAD(2,6,LAST,LINE)
      LINE(LBUF:LBUF)='&'
      I=0
 1    I=I+1
      L2=LINE(I:I+1)
      IF(L2.EQ.'  ')GOTO1
      DO2J=1,N
      IF(LIST(J).EQ.L2)THEN
         CALL SCWRIT(2,I+8,LEN,IC,LTEXT(J))
         I=I+LEN
         GOTO3
      ENDIF
 2    CONTINUE
 3    IF(I.LT.LAST)GOTO1
      END

      SUBROUTINE MODEL(ICT,IMAT)
C
C Zobrazeni textu a poctu parametru modelu
C
      LOGICAL IBLOOK
      CHARACTER LIST(4)*2,LTEXT(4)*4
      DIMENSION KAT(9,100)
      COMMON M(20000)
      COMMON /SCOM/IS(50)
      EQUIVALENCE (IBLOOK,IS(48)),(IOUT,IS(12)),(MODL,IS(41)),
     /      (KAT,M),(MPAR,KAT(5,5)),(MDPAR,KAT(8,5)),(MLINP,KAT(2,5))
C Doplneni popisu sloupcu MEDHED
      DATA LIST,LTEXT/' 1',' 2',' 3',' 4','B(i)','Bmin','Bmax','+-  '/
      IF(IMAT.EQ.5)CALL MEDHED(4,4,LIST,LTEXT)
C Vypis textu regresni funkce
      CALL MLOCR(4,MODL+1,1,LOC,ITP,LEN,IDR)
      CALL SCWRIT(19,2,LEN*4,7,M(LOC))
C Zadani poctu regres. parametru
      IF(IBLOOK.OR.ICT.EQ.45)THEN
      CALL MINPVX(0,'Set number of parameters ( [Enter] [F9] )',41,21,0,
     /'Total number of regression parameters:'//
     /'   @5I4  (number of rows)             '//
     /'Number of linear parameters in rows 1 '//
     /'to @2I4  (<=#5I4, total no. of param.)',2,19,M(37))
         MPAR=MIN0(MPAR,MDPAR)
         MLIN=MIN0(MLINP,MPAR)
         IBLOOK=.FALSE.
         IOUT=3
      ENDIF
      END

      SUBROUTINE SETKOD(ICT,IMAT)
C
C Kod matice bodu pozorovani
C
      LOGICAL IXLOOK
      CHARACTER LIST(9)*2, LTEXT(9)*4
      COMMON KAT(9,100) /SCOM/ISS(50)
      DIMENSION IX(13)
      EQUIVALENCE (IXLOOK,ISS(49)),(MAT,ISS(50)),
     /            (IOUT,ISS(12)),(IEND,ISS(13))
      DATA LTEXT/'Y   ','Wght','Yfun','X1  ','X2  ','X3  ','X4  ',
     /           'X5  ','X6  '/
      KOD=KAT(2,MAT)
      CALL DEKOD(KOD,NX,IX(4),IX(1),IX(2),IX(3))
C Popis zahlavi sloupcu
      IF(IMAT.EQ.MAT)THEN
          ND=MIN(9,NX+3)
          DO2I=1,ND
 2        CALL TPUTIS(1,IX(I),2,LIST(I))
          CALL MEDHED(ND,4,LIST,LTEXT)
      ENDIF
C Zadani panelu
      IF(IXLOOK.OR.ICT.EQ.45)THEN
      CALL MINPVX(1,'Set column indices ( [Enter] [F9] )',35,21,0,
     /'dependent vars.@1I4, weights@2I4 ( =0 '//
     /'unit weights), prediction Yfun(x)@3I4 '//
     /'independant variables:  X1@4I4  X2@5I4'//
     /'  X3@6I4  X4@7I4  X5@8I4              ',2,19,IX)
      IF(IEND.NE.27)THEN
         KOD=0
         MX=0
         DO1I=1,8
         IC=IX(I)
         IF(IC.GT.0.AND.IC.LE.8)THEN
            MX=MAX0(MX,IC)
            IC=10**(IC-1)
            IF(I.EQ.1)THEN
               KOD=KOD+2*IC
            ELSEIF(I.EQ.2)THEN
               KOD=KOD+3*IC
            ELSEIF(I.EQ.3)THEN
               KOD=KOD+4*IC
            ELSE
               KOD=KOD+IC
            ENDIF
         ENDIF
1        CONTINUE
         CALL MPARA(MAT,KKK,MAP,MROWS,NCOLS,LOC,LENGTH)
         IF(MX.GT.NCOLS)THEN
           IF(MAP.EQ.2.OR.MAP.EQ.3.AND.KAT(8,MAT).GT.0)THEN
              IF(LENGTH/KAT(8,MAT).GE.MX)KAT(6,MAT)=MX
           ENDIF
         ENDIF
         IOUT=3
         IXLOOK=.FALSE.
         KAT(2,MAT)=KOD
      ENDIF
      ENDIF
      END

      SUBROUTINE DEKOD(KOD,NX,IX,IY,IW,IP)
C
C Rozklad KOD na cislice a stanoveni indexu sloupcu X,Y,W,Predikce
C
      DIMENSION IX(*)
      NX=0
      IY=0
      IW=0
      IP=0
      DO 1 I=1,10
      IK=MOD(KOD,10)
      KOD=KOD/10
      IF(IK.EQ.1)THEN
        NX=NX+1
        IX(NX)=I
      ELSEIF(IK.EQ.2)THEN
        IY=I
      ELSEIF(IK.EQ.3)THEN
        IW=I
      ELSEIF(IK.EQ.4)THEN
        IP=I
      ENDIF
1     CONTINUE
      END

      SUBROUTINE TRALOG(IMAT)
C
C Logaritmicke transformace dat
C
      DIMENSION IX(9),KAT(9,100)
      COMMON RA(20000) /SCOM/ISS(50)
      EQUIVALENCE (IW,IX(1)),(IY,IX(2)),(KBD,ISS(13)),(KAT,RA)
      KOD=KAT(2,IMAT)
      CALL DEKOD(KOD,NX,IX(7),IX(6),IW,IP)
      CALL MINPVX(1,'Set column indices  ( [Enter] [F9] )',36,21,0,
     /'measur. data Y@2I4 > lnY@6i4, correct.'//
     /' weight@1i4 (= Y**2)                  '//
     /'independant variabs. X1@3i4 >lnX1@7i4 '//
     /' X2@4i4>lnX2@8i4  X3@5i4>lnX3@9i4     ',2,19,IX)
      IF(KBD.NE.27)THEN
         CALL MPARA(IMAT,KOD,MAP,MR,NC,LOC,LEN)
         DO1J=2,5
         IS=IX(J)
         ID=IX(J+4)
         IF(IS.GT.0.AND.IS.LE.NC.AND.ID.GT.0.AND.ID.LE.NC)THEN
            DO2I=1,MR
            CALL MLOC(IMAT,I,IS,LS,IT)
            CALL MLOC(IMAT,I,ID,LD,IT)
            IF(LD.GT.0.AND.LS.GT.0)RA(LD)=ALOG(AMAX1(1E-20,RA(LS)))
 2          CONTINUE
         ENDIF
 1       CONTINUE
         IF(IW.GT.0.AND.IW.LE.NC.AND.IY.GT.0.AND.IY.LE.NC)THEN
            DO3I=1,MR
            CALL MLOC(IMAT,I,IW,LW,IT)
            CALL MLOC(IMAT,I,IY,LY,IT)
            IF(LY.GT.0.AND.LW.GT.0)RA(LW)=RA(LY)**2
 3          CONTINUE
         ENDIF
      ENDIF
      END

      SUBROUTINE CORREL
C
C Vypocet korelacniho indexu
C
      COMMON RM(20000)/SCOM/IS(50)
      DIMENSION IV(10)
      EQUIVALENCE (IS(50),IX),(IS(41),MODL),(CORR,IS(45)),(STD,IS(2))
      EQUIVALENCE (RM(41),MPAR)
      CALL MPARA(IX,KOD,MAP,M,N,LOC,LEN)
      CALL DEKOD(KOD,NX,IV,IY,IW,IP)
      IF(NX.GT.0.AND.IY.GT.0.AND.M.GT.0.AND.IP.GT.0)THEN
         CALL MLOC(IX,1,IV,LX,IT)
         CALL MLOC(IX,1,IY,LY,IT)
         CALL MLOC(4,MODL+1,1,LT,IT)
         CALL MLOC(IX,1,IP,LP,IT)
         YMEAN=0.
         DO 1 I=1,M
         CALL MLOC(IX,I,IV,LOC,IT)
         X=RM(LOC)
         CALL MLOC(IX,I,IY,LOC,IT)
         Y=RM(LOC)
         YMEAN=YMEAN+Y
1        CONTINUE
         YMEAN=YMEAN/M
C KORELACNI INDEX
         SDEV=0.
         SDAV=0.
         DO 2 I=1,M
            CALL MLOC(IX,I,IP,LOC,IT)
            YP=RM(LOC)
            CALL MLOC(IX,I,IY,LOC,IT)
            Y=RM(LOC)
            SDEV=SDEV+(YP-Y)**2
2           SDAV=SDAV+(YMEAN-Y)**2
         CORR=SQRT(AMAX1(0.,1.-SDEV/SDAV))
         STD=SQRT(SDEV/AMAX1(1.,M-MPAR))
      ENDIF
      END

      SUBROUTINE GRAF(INIT,CXMI,CXMA,CYMI,CYMA,IMARK)
C
C Vykresleni grafu
C
      INTEGER *2     I04,I05,I07,I15,I16,I23,I31,I47,I64,I80,I81,
     /               I112,I113,I121,I240
      COMMON /SCOLR$/I04,I05,I07,I15,I16,I23,I31,I47,I64,I80,I81,
     /               I112,I113,I121,I240
      COMMON /GRAF$/IGR(30)
      DIMENSION KAT(9,100)
      LOGICAL INIT,NPT(2)
      COMMON RM(10000)/SCOM/IS(50)
      DIMENSION IV(10),RGR(30),IM(10000),ICX(2),ICY(2),X2V(2),XF(3),
     /          LOCXV(2),LOCYV(2),LOCMV(2),ICM(2)
      DOUBLE PRECISION FKCE
      EQUIVALENCE (IS(50),IX),(IS(41),MODL),(IMI,IS(24)),(IMA,IS(25)),
     /   (IM,RM,KAT),(LOCX,LOCXV),(LOCY,LOCYV),(LOCM,LOCMV),
     /   (IAXA,IGR(1)),(ICX,IGR(2)),(ICY,IGR(4)),(ICM,IGR(6)),
     /   (IX1,IGR(8)),(IX2,IGR(9)),(NX2,IGR(10)),
     /   (X2V,IGR(11)),(XF,IGR(18)),
     /   (ICOL,IGR(29)),(ICOB,IGR(30)),(IGR,RGR)
      PARAMETER (NFP=300,IB=5,IW=3)
      IAX=MOD(MOD(IAXA,10),4)
      IAXDIF=IAXA-IAX
      CALL MPARA(IX,KOD,MAP,M,N,LOC,LEN)
      CALL DEKOD(KOD,NX,IV,IDUM1,IDUM2,IDUM3)
      IF(ICY(1).LE.0) ICY(1)=IDUM1
      IF(ICX(1).LE.0.AND.NX.GT.0) ICX(1)=IV(1)
      IF(ICY(1).GT.0.AND.ICX(1).GT.0.AND.M.GT.0)THEN
C Vykreslovani znacek
         LOCX=IMI
         LOCY=LOCX+M
         LOCM=LOCY+M
         LOCXV(2)=LOCM+M
         LOCYV(2)=LOCXV(2)+M
         LOCMV(2)=LOCYV(2)+M
         IF(IMA.LT.LOCMV(2)+M) GOTO 9999
         CALL MLOC(4,MODL+1,1,LT,IT)
10       X1=1E10
         X2=-1E10
         Y1=1E10
         Y2=-1E10
         XMI=X1
         XMA=X2
         DO 2 ICO=1,2
         NPT(ICO)=.FALSE.
         IF(ICX(ICO).GT.0.AND.ICX(ICO).LE.N.AND.
     /      ICY(ICO).GT.0.AND.ICY(ICO).LE.N)THEN
         NPT(ICO)=.TRUE.
         DO 1 I=1,M
         CALL MLOC(IX,I,ICX(ICO),LOC,IT)
         X=RM(LOC)
         XMI=AMIN1(XMI,X)
         XMA=AMAX1(XMA,X)
         IF(IAX.LE.1)THEN
            IF(X.GT.0.)THEN
                X=ALOG10(X)
            ELSE
                IAX=IAX+2
                GOTO 10
            ENDIF
         ENDIF
         RM(LOCXV(ICO)+I)=X
         CALL MLOC(IX,I,ICY(ICO),LOC,IT)
         Y=RM(LOC)
         IF(IAX.EQ.0.OR.IAX.EQ.2)THEN
            IF(Y.GT.0.)THEN
               Y=ALOG10(Y)
            ELSE
               IAX=IAX+1
               GOTO 10
            ENDIF
         ENDIF
         RM(LOCYV(ICO)+I)=Y
         IF(ICM(ICO).LT.0.AND.ICM(ICO).GE.-N)THEN
            CALL MLOC(IX,I,-ICM(ICO),LOC,IT)
            IM(LOCMV(ICO)+I)=RM(LOC)
         ELSE
            IM(LOCMV(ICO)+I)=ICM(ICO)
         ENDIF
         X1=AMIN1(X1,X)
         X2=AMAX1(X2,X)
         Y1=AMIN1(Y1,Y)
         Y2=AMAX1(Y2,Y)
1        CONTINUE
         ENDIF
2        CONTINUE
         IF(INIT)THEN
             CALL GMFIN
             CALL SCWRIT(24,0,40,3,RM(LT))
             LENTEX=16
         ELSE
             LENTEX=8
         ENDIF
         CALL GMFSYL(IGR(21),LENTEX,IGR(25),LENTEX)
         IF(IAX.EQ.3)THEN
            IWIND=2
         ELSE
            IWIND=-2
         ENDIF
         IF(IMARK.LE.11)THEN
            CALL GMFSTE(IWIND,CXMI,CXMA,CYMI,CYMA,X1,X2,Y1,Y2)
            CALL GMFAXE(2,IAX+IAXDIF,ICOB)
            DO 102 ICO=1,2
            IF(NPT(ICO))THEN
            DO 101 I=1,M
101         CALL GMFMRK(RM(LOCXV(ICO)+I),RM(LOCYV(ICO)+I),
     /                  IM(LOCMV(ICO)+I))
            ENDIF
102         CONTINUE
         ELSE
            CALL GMFSW(2)
         ENDIF
C Vykresleni funkci
         MPAR=KAT(5,IB)
         LOCP=KAT(1,IB)
         LW=KAT(1,IW)-1
         LOCY=LOCX+NFP
         IF(IX1.GT.0.AND.IX1.LE.NX)THEN
            DX1=(XMA-XMI)/NFP
            DO J=1,3
               IXN=IGR(J+14)
               IF(IXN.GT.0.AND.IXN.LE.NX)RM(LW+IXN)=RGR(J+17)
            END DO
            DO J=1,NX2
            IF(IX2.GT.0.AND.IX2.LE.NX)RM(LW+IX2)=RGR(J+10)
            XW=XMI
            DO 200 L=1,NFP
            RM(LW+IX1)=XW
            IF(IAX.LE.1)THEN
               RM(LOCX+L)=ALOG10(XW)
            ELSE
               RM(LOCX+L)=XW
            ENDIF
C volani regresniho modelu
            RV=FKCE(RM(LW+1),RM(LOCP),MPAR)
            IF(IAX.EQ.0.OR.IAX.EQ.2)THEN
               IF(RV.GT.0.)THEN
                  RV=ALOG10(RV)
               ELSE
                  RV=Y1
               ENDIF
            ENDIF
            RM(LOCY+L)=RV
200         XW=XW+DX1
            CALL GMFPL(NFP,RM(LOCX+1),RM(LOCY+1),ICOL)
            END DO
            IF(IMARK.GT.10)CALL GMFMRK(RM(LOCX+NFP),RM(LOCY+NFP),IMARK)
         ENDIF
         IF(INIT)THEN
            CALL GMFLAB(7)
            CALL GMFMON
         ENDIF
      ENDIF
9999  END

      SUBROUTINE SERR(IERR)
C
C Hlaseni chyb MATSOF
C
C Verze: 4:54:39  8/14/1989
C
      CHARACTER *1 TYP(5), TEXT(2)*12, ITX*12, ITY*3
      INTEGER *2     I04,I05,I07,I15,I16,I23,I31,I47,I64,I80,I81,
     /               I112,I113,I121,I240,ICOLR
      COMMON /SCOLR$/I04,I05,I07,I15,I16,I23,I31,I47,I64,I80,I81,
     /               I112,I113,I121,I240
      COMMON/SCOM/IER,IW(9),ITR,IV(39)
      DATA TYP/'S','F','M','T','G'/ ITX/'ERROR:      '/
      DATA TEXT/' Accuracy ? ',
     /          'Out of space'/
      IER=IERR
      IF(ITR.GE.0.AND.IER.NE.0)THEN
         IA=IABS(IERR)
         IM=MOD(IA,1000)
         IT=MIN0(5,MAX0(1,MOD(IA/1000,10)))
         IS=IA/10000
         IF(IM.GE.8.AND.IM.LE.9)THEN
            CALL SCWRIT(24,60,12,I07,TEXT(IM-7))
         ELSE
            CALL TPUTIS(9,IM,4,ITX)
            CALL SCWRIT(24,60,12,I07,ITX)
         ENDIF
         IF(IS.GT.0)THEN
            CALL TPUTIS(1,IS,3,ITY)
            CALL SCWRIT(24,73,3,I07,ITY)
         ENDIF
         IF(IER.GT.0)THEN
            LOOP=10
         ELSE
            LOOP=60
         ENDIF
         DO 10 I=1,LOOP
         ICOLR=7
1        CALL SCWRIT(24,72,1,ICOLR,TYP(IT))
         ICOLR=ICOLR+1
         IF(ICOLR.LE.128) GOTO 1
         CALL SKBDS(KBD)
         IF(KBD.NE.0) GOTO 2
10       CONTINUE
      ENDIF
2     END

